<template>
<svg ref="svg" :class='[ type, { "hover": hover } ]' viewBox="0 0 213 60" fill="none" xmlns="http://www.w3.org/2000/svg">
	<g class="transition" :fill='type == "grey" ? "#fff" : `url(#${type}_${_uid})`' :opacity='opacity'>
		<g class="left">
			<rect width="61.62" height="60" :clip-path='`url(#clip_${_uid}_left)`' />
		</g>
		<g class="center">
			<rect height="60" x="61" />
		</g>
		<g class="right">
			<rect width="61.62" height="60" :clip-path='`url(#clip_${_uid}_right)`' />
		</g>
	</g>
	<defs>
		<radialGradient class="primary_gradient transition" :id='`primary_${_uid}`' gradientUnits="userSpaceOnUse" x1="0" y1="0" x2="100%" y2="100%" r="100%" gradientTransform="translate(-40 -20)">
			<stop stop-color="#F5621C"/>
			<stop offset="1" stop-color="#D432D6"/>
		</radialGradient>

		<radialGradient class="yellow_gradient transition" :id='`yellow_${_uid}`' gradientUnits="userSpaceOnUse" x1="0" y1="0" x2="100%" y2="100%" r="80%" gradientTransform="translate(-20 -20)">
			<stop stop-color="#FEC724"/>
			<stop offset="1" stop-color="#F68B41"/>
		</radialGradient>

		<clipPath :id='`clip_${_uid}_left`'>
			<path d="M9.4999 0H61.621V30V60H9.53311C5.56338 60 2.17959 57.086 1.67569 53.1483C-0.523044 35.9673 -0.587009 24.0027 1.65567 6.81543C2.16739 2.89325 5.54483 0 9.4999 0Z"/>
		</clipPath>

		<clipPath :id='`clip_${_uid}_right`'>
			<path d="M52.4999 0H0.378784V60H52.4667C56.4364 60 59.8203 57.086 60.3242 53.1483C62.5229 35.9673 62.5869 24.0027 60.3442 6.81543C59.8325 2.89325 56.455 0 52.4999 0Z"/>
		</clipPath>
	</defs>
</svg>
</template>

<script>
export default {
	props: {
		content: {
			type: String,
			default: ""
		},
		type: {
			type: String,
			default: "primary",
			validator: val => [ "primary", "yellow", "grey" ].includes(val)
		},
		hover: {
			type: Boolean,
			default: false
		},
		width: Number,
		fullwidth: Boolean
	},
	computed: {
		opacity() {
			if (this.type == "grey") {
				if (this.hover)
					return "0.19"
				return "0.05"
			}

			return 1
		}
	},
	watch: {
		content() {
			this.$nextTick(this.renderBg)
		}
	},
	methods: {
		renderBg() {
			const { svg } = this.$refs

		 	if (!svg)
				return

			let p = document.createElement("p")
			p.innerHTML = `${this.content}&nbsp;&nbsp;`
			p.style.fontSize = "13px"
			p.style.fontWeight = "800"
			p.style.textTransform = "uppercase"
			p.style.display = "inline-block"
			p.setAttribute("id", `_${this._uid}`)
			document.body.appendChild(p)
			p = document.querySelector(`#_${this._uid}`)
			p = p
			const text_width = p.clientWidth < 8 ? 8 : p.clientWidth
			p.remove()

			let parent_width = 0
			if (this.fullwidth) {
				parent_width = svg.parentNode.parentNode.parentNode.clientWidth - (this.isPhone || this.isTablet ? .45 * 32 : .625 * 32)
			}

			const width = parent_width || this.width || text_width + (51 * 2)
			svg.setAttribute("viewBox", `0 0 ${width > 0 ? width : 0} 60`)
			svg.setAttribute("width", `${width / 16}rem`)

			const rect_width = width - (61.2 * 2)
			svg.querySelector(".center rect").setAttribute("width", rect_width > 0 ? rect_width : 0)

			const left_coord = 60.3 + rect_width
 			svg.querySelector(".right rect").setAttribute("x", left_coord)
			svg.querySelector(`#clip_${this._uid}_right path`).setAttribute("transform", `translate(${left_coord})`)
		}
	},
	mounted() {
		this.renderBg()

		window.addEventListener("resize", this.renderBg)
	}
}
</script>

<style lang="scss" scoped>
.transition {
	transition: all .2s ease-in-out;
}

// Primary
// <stop stop-color=""/>
// <stop offset="1" stop-color=""/>

// Yellow
// <stop stop-color="#FABB00"/>
// <stop offset="1" stop-color="#F9814E"/>

stop {
	transition: all .2s ease-in-out;
}

$types: (
	"primary": (
		#FC7637, #EC36EE
	), 
	"yellow": (
		#FABB00, #F9814E
	)
);

@each $type, $colors in $types {
	.hover {
		.#{$type}_gradient {
			stop {
				&:first-of-type {
					stop-color: nth($colors, 1)!important;
					offset: 40%;
				}
				&:last-of-type {
					stop-color: nth($colors, 2)!important;
					offset: 60%;
				}
			}
		}
	}
}
</style>